//Fill Can by Zor
//Modified by McTwist(9845) - FaceGlitched fixed by Mr.NoBody (6480) *again
//Editor note: The code style has been preserved. Just using new techniques.

// Change $Pref::Server::FillCan_MaxBricks in-game in the console, example:
//   $Pref::Server::FillCan_MaxBricks = 600;

if($Pref::Server::FillCan_MaxBricks$="")
 $Pref::Server::FillCan_MaxBricks=5000;

// Mark all bricks from one brick
function fillcan_markbricks(%client,%obj,%newcolor,%done){
 if(isEventPending(%client.fillcan))
  return;
 %oldcolor=%obj.getcolorid();
 if(%client.isAdmin || %client.isSuperAdmin)
  %limit=0;
 else
  %limit=$Pref::Server::FillCan_MaxBricks;
 %list=new scriptobject(){count=0; oldcolor=%oldcolor; newcolor=%newcolor;};
 missioncleanup.add(%list);
 %client.paintfill=%list;
 %list.obj[%list.count++-1]=%obj;
 $FillCan_fill[%list,%obj]=1;
 %client.fillcan=scheduleNoQuota(33,%list,fillcan_markbricks_schedule,%client,%list,%done,0,%limit);
}
function fillcan_markbricks_schedule(%client,%list,%done,%x,%limit){
 if(%x>500&&%x%100==0)
  bottomprint(%client,"\c3Gathering bricks..." SPC %x,2,3);
 for(%endx=%x+20;%x<%list.count;%x++){
  if(%x>=%endx){
   %client.fillcan=scheduleNoQuota(33,%list,fillcan_markbricks_schedule,%client,%list,%done,%x,%limit);
   return;
  }
  %obj=%list.obj[%x];
  if(!isObject(%obj))
   continue;
  %data=%obj.getdatablock();
  %rot=round(getword(%obj.rotation,3));
  if(%rot==90 || %rot==270){
   %sizex=%data.bricksizey;
   %sizey=%data.bricksizex;
  }else{
   %sizex=%data.bricksizex;
   %sizey=%data.bricksizey;
  }
  %sizez=%data.bricksizez;
  %box=(%sizex*0.5+0.6) SPC (%sizey*0.5+0.6) SPC (%sizez*0.2+0.3);
  InitContainerBoxSearch(%obj.getposition(),%box,$typemasks::fxbrickobjecttype);
  while((%limit==0||%list.count<%limit)&&%target=containerSearchNext()){
   if(!$FillCan_fill[%list,%target] &&
     %target.isplanted() && %target.getcolorid()==%list.oldcolor &&
     gettrustlevel(%client,%target)>=2){
    $FillCan_fill[%list,%target]=1;
    %list.obj[%list.count++-1]=%target;
   }
  }
  if(%limit!=0&&%list.count>=%limit){
   messageclient(%client,'MsgPlantError_Limit');
   centerprint(%client,"\c3Reached Fill Can Brick Limit ("@%limit@")",2,3);
   break;
  }
 }
 deletevariables("$FillCan_fill"@%list@"_*");
 if(%x>500)
  bottomprint(%client,"",1,1);
 if(isFunction(%done))
  %client.fillcan=scheduleNoQuota(0,%list,call,%done,%client,%list);
 else
  %client.paintfill="";
}

function paintfill(%client,%list){
 if(isEventPending(%client.fillcan))
  return;
 %list.type="paint";
 %client.paintfill=%list;
 %client.fillcan=scheduleNoQuota(0,%list,paintfill_schedule,%client,%list,0);
}

function paintfill_schedule(%client,%list,%x){
 for(%endx=%x+400;%x<%list.count;%x++){
  if(%x>=%endx){
   %client.fillcan=scheduleNoQuota(33,%list,paintfill_schedule,%client,%list,%x);
   return;
  }
  %obj=%list.obj[%x];
  if(!isObject(%obj))
   continue;
  %obj.setcolor(%list.newcolor);
 }
 bottomprint(%client,"",1,1);
 %client.paintfill="";
 %client.undostack.push(%list TAB "FILLPAINT");
}

function paintFXfill(%client,%list){
 if(isEventPending(%client.fillcan))
  return;
 %list.type="PAINTFX";
 %client.paintfill=%list;
 %client.fillcan=scheduleNoQuota(0,%list,paintFXfill_schedule,%client,%list,0);
}

function paintFXfill_schedule(%client,%list,%x){
 for(%endx=%x+500;%x<%list.count;%x++){
  if(%x>=%endx){
   %client.fillcan=scheduleNoQuota(33,%list,paintFXfill_schedule,%client,%list,%x);
   return;
  }
  %obj=%list.obj[%x];
  if(!isObject(%obj))
   continue;
  if(%obj.getcolorfxid())
   %list.oldfx[%x]=%obj.getcolorfxid();
  %obj.setcolorfx(%list.newcolor);
 }
 bottomprint(%client,"",1,1);
 %client.paintfill="";
 %client.undostack.push(%list TAB "FILLPAINT");
}

function shapeFXfill(%client,%list){
 if(isEventPending(%client.fillcan))
  return;
 %list.type="SHAPEFX";
 %list.newcolor+=7;
 %client.paintfill=%list;
 %client.fillcan=scheduleNoQuota(0,%list,shapeFXfill_schedule,%client,%list,0);
}

function shapeFXfill_schedule(%client,%list,%x){
 for(%endx=%x+500;%x<%list.count;%x++){
  if(%x>=%endx){
   %client.fillcan=scheduleNoQuota(33,%list,shapeFXfill_schedule,%client,%list,%x);
   return;
  }
  %obj=%list.obj[%x];
  if(!isObject(%obj))
   continue;
  if(%obj.getshapefxid())
   %list.oldfx[%x]=%obj.getshapefxid();
  %obj.setshapefx(%list.newcolor-7);
 }
 bottomprint(%client,"",1,1);
 %client.paintfill="";
 %client.undostack.push(%list TAB "FILLPAINT");
}

function paintundo(%client,%list){
 if(isEventPending(%client.fillcan))
  return;
 %client.player.playthread(0,undo);
 %client.paintfill=%list;
 %client.fillcan=scheduleNoQuota(0,%list,paintundo_schedule,%client,%list,%list.count-1);
}

function paintundo_schedule(%client,%list,%x){
 for(%endx=%x-500;%x>=0;%x--){
  if(%x<=%endx){
   %client.fillcan=scheduleNoQuota(33,%list,paintundo_schedule,%client,%list,%x);
   return;
  }
  %obj=%list.obj[%x];
  if(!isObject(%obj))
   continue;
  if(%obj.getcolorid()==%list.newcolor)
   %obj.setcolor(%list.oldcolor);
 }
 bottomprint(%client,"",1,1);
 %client.undostack.pop();
 %client.paintfill="";
 %list.delete();
}

function paintFXundo(%client,%list){
 if(isEventPending(%client.fillcan))
  return;
 %client.player.playthread(0,undo);
 %client.paintfill=%list;
 %client.fillcan=scheduleNoQuota(0,%list,paintFXundo_schedule,%client,%list,%list.count-1);
}

function paintFXundo_schedule(%client,%list,%x){
 for(%endx=%x-500;%x>=0;%x--){
  if(%x<=%endx){
   %client.fillcan=scheduleNoQuota(33,%list,paintFXundo_schedule,%client,%list,%x);
   return;
  }
  %obj=%list.obj[%x];
  if(!isObject(%obj))
   continue;
  if(%obj.getcolorfxid()==%list.newcolor)
   %obj.setcolorfx(%list.oldfx[%x]);
 }
 bottomprint(%client,"",1,1);
 %client.paintfill="";
 %client.undostack.pop();
 %list.delete();
}

function shapeFXundo(%client,%list){
 if(isEventPending(%client.fillcan))
  return;
 %client.player.playthread(0,undo);
 %list.newcolor-=7;
 %client.paintfill=%list;
 %client.fillcan=scheduleNoQuota(0,%list,shapeFXundo_schedule,%client,%list,%list.count-1);
}

function shapeFXundo_schedule(%client,%list,%x){
 for(%endx=%x-500;%x>=0;%x--){
  if(%x<=%endx){
   %client.fillcan=scheduleNoQuota(33,%list,shapeFXundo_schedule,%client,%list,%x);
   return;
  }
  %obj=%list.obj[%x];
  if(!isObject(%obj))
   continue;
  if(%obj.getshapefxid()==%list.newcolor)
   %obj.setshapefx(%list.oldfx[%x]);
 }
 bottomprint(%client,"",1,1);
 %client.paintfill="";
 %client.undostack.pop();
 %list.delete();
}

function fillcan_cancel(%client){
 if(isObject(%client.paintfill)){
  if(%client.paintfill.type!$="")
   return;
  deletevariables("$FillCan_fill"@%client.paintfill@"_*");
  %client.paintfill.delete();
  %client.paintfill="";
 }
 %client.fillcan="";
 cancel(%client.fillcan);
}

datablock ParticleData(fillcanTrailParticle)
{
 dragCoefficient     = 3.0;
 windCoefficient     = 0.0;
 gravityCoefficient  = 0.0;
 inheritedVelFactor  = 0.0;
 constantAcceleration    = 0.0;
 lifetimeMS      = 420;
 lifetimeVarianceMS  = 0;
 spinSpeed       = 0.0;
 spinRandomMin       = -50.0;
 spinRandomMax       = 50.0;
 useInvAlpha     = false;
 animateTexture      = false;
 //framesPerSec      = 1;

 textureName     = "base/data/particles/star1";
 //animTexName       = "~/data/particles/dot";

 // Interpolation variables
 colors[0]   = "0.7 0.7 1 0.2";
 colors[1]   = "0.4 0.4 1 0.1";
 sizes[0]    = 0.4;
 sizes[1]    = 0.01;
 times[0]    = 0.0;
 times[1]    = 1.0;
};

datablock ParticleEmitterData(fillcanTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 20;
   velocityVariance = 0;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 0.0;  

   phiReferenceVel = 0;
   phiVariance = 360;

   particles = fillcanTrailParticle;
};

//effects
datablock ParticleData(fillcanExplosionParticle)
{
 dragCoefficient      = 5;
 gravityCoefficient   = 0.1;
 inheritedVelFactor   = 0.2;
 constantAcceleration = -0.1;
 lifetimeMS           = 700;
 lifetimeVarianceMS   = 300;
 textureName          = "base/data/particles/dot";
 spinSpeed       = 0.0;
 spinRandomMin       = -50.0;
 spinRandomMax       = 50.0;
 colors[0]     = "0.6 0.6 0.9 0.9";
 colors[1]     = "0.6 0.6 0.6 0.0";
 sizes[0]      = 0.25;
 sizes[1]      = 0.0;
};

datablock ParticleEmitterData(fillcanExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "fillcanExplosionParticle";
};

datablock ExplosionData(fillcanExplosion)
{
   //explosionShape = "";
//  soundProfile = 0;

   lifeTimeMS = 150;

   particleEmitter = fillcanExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.6 0.6 0.9";
   lightEndColor = "0 0 0";
};


//projectile
datablock ProjectileData(fillcanProjectile)
{
   //projectileShapeName = "./shapes/arrow.dts";

   directDamage        = 0;
   directDamageType    = $DamageType::ArrowDirect;

   radiusDamage        = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::ArrowDirect;

   explosion           = fillcanExplosion;
//   particleEmitter     = fillcanTrailEmitter;

   muzzleVelocity      = 20;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 500;
   fadeDelay           = 250;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(fillcanItem)
{
 category = "Weapon";  // Mission editor category
 className = "Weapon"; // For inventory system

  // Basic Item Properties
 shapeFile = "base/data/shapes/spraycan.dts";
 rotate = false;
 mass = 1;
 density = 0.2;
 elasticity = 0.2;
 friction = 0.6;
 emap = true;

 //gui stuff
 uiName = "Fill Can";
 iconName = "./icon_fillcan";
 doColorShift = true;
 colorShiftColor = "0.85 0.85 1 1";

  // Dynamic properties defined by the scripts
 image = fillcanImage;
 canDrop = true;
};

datablock ShapeBaseImageData(fillcanImage : rainbowSprayCanImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/spraycan.dts";

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.7 1 -0.6";
   rotation = eulerToMatrix( "0 0 10" );

   // Projectile && Ammo.
   item = fillcanItem;
   ammo = " ";
   projectile = fillcanProjectile;
   projectileType = Projectile;
   minShotTime = 700;

   doColorShift = true;
   colorShiftColor = fillcanItem.colorShiftColor;

   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateTimeoutValue[2] = 0.7;
   stateEmitter[2] = fillcanTrailEmitter;

   stateName[5]   = "NoAmmo";
   stateScript[5]="onNoAmmo";
   stateTransitionOnAmmo[5] = "Ready";
};

function fillcanprojectile::oncollision(%this,%obj,%col,%fade,%pos,%normal){
 %client=%obj.client;
 if(!isobject(%client))
  return;
 if(%col.getclassname()$=fxdtsbrick){
  if(isobject(%client.minigame)){
   if(!%client.minigame.enablepainting){
    centerprint(%client,"\c5Painting is currently disabled.",3,3);
    return;
   }
  }
  if(gettrustlevel(%obj.client,%col)>=2){
    if(%client.currentFXcan){
     if(%client.currentFXcan>7)
      fillcan_markbricks(%obj.client,%col,%obj.client.currentFXcan-8,shapeFXfill);
     else
      fillcan_markbricks(%obj.client,%col,%obj.client.currentFXcan-1,paintFXfill);
    }else if(%col.getcolorid()!=%obj.client.currentcolor)
     fillcan_markbricks(%obj.client,%col,%obj.client.currentcolor,paintfill);
  }else{
   %name=%col.getgroup().name;
   centerprint(%client,%name@" does not trust you enough to do that.",3,3);
  }
 }else if(%col.getclassname()$=player){
  if(%client.currentfxcan){
   %rand=getrandom(0,$randfacecount-1);
   cancel(%col.faceresetsched);
   %col.faceresetsched=schedule(2500,0,resetface,%col);
   %col.setfacename($randface[%rand]);
   if(%col.client.accent==1)
    %col.setnodecolor("visor",getwords(%col.client.accentcolor,0,2) SPC "0.7");
  }else{
   %color=getcoloridtable(%obj.client.currentcolor);
   %col.settempcolor(%color,2500);
//   if(getword(%color,3)==1)
//    %col.emote(hateimage);
  }
 }else if(%col.getclassname()$=wheeledvehicle || %col.getclassname()$=flyingvehicle){
  if(gettrustlevel(%client,%col.spawnbrick)>=2){
   if(%client.currentfxcan){
     %client.undostack.push(%col TAB "COLORGENERIC" TAB %col.color);
     %recolor=0;
     if(%col.spawnbrick.recolorvehicle){
      %col.spawnbrick.recolorvehicle=0;
      %recolor=1;
     }
     %col.color=(getrandom(0,100)/100) SPC (getrandom(0,100)/100) SPC (getrandom(0,100)/100) SPC "1";
     %col.spawnbrick.colorvehicle();
     if(%recolor)
      %col.spawnbrick.recolorvehicle=1;
   }else{
    if(%col.spawnbrick.recolorvehicle){
     %col.spawnbrick.setcolor(%client.currentcolor);
     %col.color=getcoloridtable(%client.currentcolor);
     %col.spawnbrick.colorvehicle();
     %client.undostack.push(%col.spawnbrick TAB "COLOR" TAB %col.spawnbrick.getcolorid());
     for(%x=0;%x<%col.getmountedobjectcount();%x++)
       %col.getmountedobject(%x).settempcolor(%col.color,2500);
    }else{
     %col.color=setword(getcoloridtable(%client.currentcolor),3,1);
     %col.spawnbrick.colorvehicle();
     %client.undostack.push(%col TAB "COLORGENERIC" TAB %col.color);
     for(%x=0;%x<%col.getmountedobjectcount();%x++)
       %col.getmountedobject(%x).settempcolor(%col.color,2500);
    }
   }
  }else
   centerprint(%client,%col.spawnbrick.getgroup().name@" does not trust you enough to do that.",3,3);
 }
}

$randface0="smiley";
$randface1="asciiTerror";
$randface2="memeBlockMongler";
$randface3="memeCats";
$randface4="memeDesu";
$randface5="memeGrinMan";
$randface6="memeHappy";
$randface7="memePBear";
$randface8="memeYaranika";
$randface9="smileyBlonde";
$randface10="smileyCreepy";
$randface11="smileyEvil1";
$randface12="smileyEvil2";
$randface13="smileyFemale1";
$randface14="smileyOld";
$randface15="smileyPirate1";
$randface16="smileyPirate2";
$randface17="smileyPirate3";
$randface18="smileyRedBeard";
$randface19="smileyRedBeard2";
$randfacecount=20;

function resetface(%obj){
 if(!isobject(%obj))
  return;
 %obj.setfacename(%obj.client.facename);
 if(%obj.client.accent==1)
  %obj.setnodecolor("visor",%obj.client.accentcolor);
}

function servercmdfillcan(%client){
 if(isobject(%client.minigame)){
  if(!%client.minigame.enablepainting){
   centerprint(%client,"\c5Painting is currently disabled.",3,3);
   return;
  }
 }
 %client.player.updatearm(fillcanimage);
 %client.player.mountimage(fillcanimage,0);
}

package fillcan{
 function servercmdundobrick(%client){
  %str=%client.undostack.val[%client.undostack.head-1];
  if(getfield(%str,1)$="FILLPAINT"){
   %list=getfield(%str,0);
   switch$(%list.type){
   case "PAINT":
    paintundo(%client,%list);
   case "PAINTFX":
    paintFXundo(%client,%list);
   case "SHAPEFX":
    shapeFXundo(%client,%list);
   }
  }else
   parent::servercmdundobrick(%client);
 }

 function servercmdusefxcan(%client,%can){
  if(%client.player.getmountedimage(0)==fillcanimage.getid())
   %remount=1;
  parent::servercmdusefxcan(%client,%can);
  if(%remount)
   %client.player.mountimage(fillcanimage,0);
  %client.currentFXcan=%can+1;
 }
 function servercmdusespraycan(%client,%can){
  if(%client.player.getmountedimage(0)==fillcanimage.getid())
   %remount=1;
  parent::servercmdusespraycan(%client,%can);
  if(%remount)
   %client.player.mountimage(fillcanimage,0);
  %client.currentFXcan=0;
 }
 function gameconnection::onclientleavegame(%client){
  fillcan_cancel(%client);
  for(%x=%client.undostack.tail;%x<%client.undostack.head;%x++){
   %t=%client.undostack.val[%x];
   if(getword(%t,1)$="FILLPAINT")
    getword(%t,0).delete();
  }
  parent::onclientleavegame(%client);
 }
 function gameconnection::ondeath(%client, %killerPlayer, %killer, %damageType, %damageLoc){
  fillcan_cancel(%client);
  parent::ondeath(%client, %killerPlayer, %killer, %damageType, %damageLoc);
 }
 function gameconnection::spawnplayer(%client){
  fillcan_cancel(%client);
  parent::spawnplayer(%client);
 }
 function servercmdunusetool(%client){
  fillcan_cancel(%client);
  parent::servercmdunusetool(%client);
 }
};
activatepackage(fillcan);

function round(%a){
 %a+=0.5;
 if(%a>0)
  return(%a-((%a*1000000 % 1000000)/1000000));
 else
  return(%a+((%a*-1000000 % 1000000)/1000000)-1);
}
